/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2003 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.dynamo.iface;

import java.security.Principal;
import com.silverwrist.dynamo.except.ModuleException;
import com.silverwrist.dynamo.util.QualifiedNameKey;

public interface ModuleFunctions
{
  public QualifiedNameKey getModuleID();

  public String getDescription();

  public void initialize(ModuleSite site, ServiceProvider services) throws ModuleException;

  public void shutdown();

  public boolean inUse();

  public boolean canInstall(ServiceProvider services, Principal installer);

  public void install(ModuleSite site, ServiceProvider services, Principal installer, DynamoLog log)
      throws ModuleException;

  public void uninstall(ModuleSite site, ServiceProvider services, Principal uninstaller, DynamoLog log)
      throws ModuleException;

  public DynamicObject getProvidedObject(String namespace, String name) throws ModuleException;

} // end interface ModuleFunctions
